//Code by Patcas Csaba
//Time complexity: ^$%&$%&%$@#@
//Space complexity: O(1)
//Method: Double backtracking
//Implementation time: 1 h 30 min

#include <vector>
#include <string> 
#include <set> 
#include <map> 
#include <queue> 
#include <bitset> 
#include <stack>
#include <list>

#include <numeric> 
#include <algorithm> 

#include <cstdio>
#include <fstream>
#include <iostream> 
#include <sstream> 
#include <iomanip>

#include <cctype>
#include <cmath> 
#include <ctime>
#include <cassert>

using namespace std;

#define LL long long
#define PII pair <int, int>
#define VB vector <bool>
#define VI vector <int>
#define VD vector <double>
#define VS vector <string>
#define VPII vector <pair <int, int> >
#define VVI vector < VI >
#define VVB vector < VB >

#define FORN(i, n) for(int i = 0; i < (n); ++i)
#define FOR(i, a, b) for(int i = (a); i <= (b); ++i)
#define FORD(i, a, b) for(int i = (a); i >= (b); --i)
#define FORI(it, X) for(__typeof((X).begin()) it = (X).begin(); it !=(X).end(); ++it) 
#define REPEAT do{ 
#define UNTIL(x) }while(!(x)); 

#define SZ size()
#define BG begin() 
#define EN end() 
#define CL clear()
#define X first
#define Y second
#define RS resize
#define PB push_back
#define MP make_pair
#define ALL(x) x.begin(), x.end()

#define IN_FILE "cumpanit.in"
#define OUT_FILE "cumpanit.out"

ifstream fin(IN_FILE);
ofstream fout(OUT_FILE);

int nrPrimes;
LL n, m;
VI primes, ss, ss2;
vector < vector <LL> > primePowers;
vector <LL> solution;

void buildPrimes()
{
	primes.PB(2);
	primes.PB(3);
	primes.PB(5);
	primes.PB(7);
	primes.PB(11);
	primes.PB(13);
	primes.PB(17);
	primes.PB(19);
	primes.PB(23);
	primes.PB(29);
	primes.PB(31);
	primes.PB(37);
	primes.PB(41);
	primes.PB(43);
	nrPrimes = primes.SZ;
}

void buildPrimePowers()
{
	primePowers.RS(nrPrimes, vector <LL> (47));
	FORN(i, nrPrimes)
	{
		LL aux = 1;
		FOR(j, 1, 46)
		{
			aux *= primes[i];
			if (aux > 100000000000000) break;
			primePowers[i][j] = aux;
		}
	}
}

void check(int sp)
{
	LL p = 1;
	FOR(i, 1, sp)
	{
		if (primePowers[ss[i]][ss2[i]] == 0) return;
		if (primePowers[ss[i]][ss2[i]] <= (100000000000000 / p)) p *= primePowers[ss[i]][ss2[i]];
		else return;
		if (p > m) return;
	}
	if (p >= n) 
	{
		solution.PB(p);
	}
}

void doBack2(int sp2, int sp, int sum)
{
	if (sp2 == sp)
	{
		ss2[sp2] = sum;
		check(sp);
		return;
	}
	FOR(i, 1, sum - sp + sp2)
	{
		ss2[sp2] = i;
		doBack2(sp2 + 1, sp, sum - i);
	}
}

void doBack(int sp, int sum)
{
	if (sum > 46 || primePowers[0][sum] > m) return;
	FOR(i, ss[sp - 1] + 1, nrPrimes - 1)
	{
		ss[sp] = i;
		if (sum + primes[i] <= 46) doBack2(1, sp, sum + primes[i]);
		doBack(sp + 1, sum + primes[i]);
	}
}

int main()
{
	//Read data
	fin >> n >> m;
	fin.close();

	//Solve
	buildPrimes();
	buildPrimePowers();
	
	//Write data
	ss.RS(nrPrimes + 1);
	ss2.RS(nrPrimes + 1);
	ss[0] = -1;
	doBack(1, 0);

	sort(ALL(solution));
	FORN(i, solution.SZ) fout << solution[i] << endl;
	fout.close();

	return 0;
}