//Code by Patcas Csaba
//Time complexity: O(n * m * log(n * m))
//Space complexity: O(n * m)
//Method: Heap
//Implementation time: 30 minutes

#include <vector>
#include <string> 
#include <set> 
#include <map> 
#include <queue> 
#include <bitset> 
#include <stack>
#include <list>

#include <numeric> 
#include <algorithm> 

#include <cstdio>
#include <fstream>
#include <iostream> 
#include <sstream> 
#include <iomanip>

#include <cctype>
#include <cmath> 
#include <ctime>
#include <cassert>

using namespace std;

#define LL long long
#define PII pair <int, int>
#define VB vector <bool>
#define VI vector <int>
#define VD vector <double>
#define VS vector <string>
#define VPII vector <pair <int, int> >
#define VVI vector < VI >
#define VVB vector < VB >

#define FORN(i, n) for(int i = 0; i < (n); ++i)
#define FOR(i, a, b) for(int i = (a); i <= (b); ++i)
#define FORD(i, a, b) for(int i = (a); i >= (b); --i)
#define FORI(it, X) for(__typeof((X).begin()) it = (X).begin(); it !=(X).end(); ++it) 
#define REPEAT do{ 
#define UNTIL(x) }while(!(x)); 

#define SZ size()
#define BG begin() 
#define EN end() 
#define CL clear()
#define X first
#define Y second
#define RS resize
#define PB push_back
#define MP make_pair
#define ALL(x) x.begin(), x.end()

#define IN_FILE "taxa.in"
#define OUT_FILE "taxa.out"

ifstream fin(IN_FILE);
ofstream fout(OUT_FILE);

int n, m, xs, xf, ys, yf;
int dx[8] = {-1, -1, -1, 0, 0, 1, 1, 1};
int dy[8] = {-1, 0, 1, -1, 1, -1, 0, 1};
VVI a;
VVB was;
priority_queue < pair <int, PII>, vector <pair <int, PII> >, greater<pair <int, PII> > > heap;

int solve()
{
	was.RS(n + 1, VB(m + 1));
	heap.push(MP(0, MP(xs, ys)));
	was[xs][ys] = true;
	while (1)
	{
		int cost = heap.top().X;
		PII coord = heap.top().Y;
		if (coord.X == xf && coord.Y == yf) return cost;
		heap.pop();
		FORN(i, 8)
		{
			int newX = coord.X + dx[i];
			int newY = coord.Y + dy[i];
			if (newX < 1 || newX > n || newY < 1 || newY > m) continue;
			if (was[newX][newY]) continue;
			was[newX][newY] = true;
			int newCost;
			if (a[coord.X][coord.Y] != a[newX][newY]) newCost = cost + a[coord.X][coord.Y] * a[newX][newY];
			else newCost = cost;
			heap.push(MP(newCost, MP(newX, newY)));
		}
	}
}

int main()
{
	//Read data
	fin >> n >> m >> xs >> ys >> xf >> yf;
	a.RS(n + 1, VI(m + 1));
	FOR(i, 1, n)
		FOR(j, 1, m) fin >> a[i][j];
	fin.close();

	//Solve

	//Write data
	fout << solve();
	fout.close();

	return 0;
}