//Code by Patcas Csaba
//Time complexity: O(n * m)
//Space complexity: O(n * m)
//Method: Fill + BF
//Implementation time:  40 minutes
//Only works for the two color case

#include <vector>
#include <string> 
#include <set> 
#include <map> 
#include <queue> 
#include <bitset> 
#include <stack>
#include <list>

#include <numeric> 
#include <algorithm> 

#include <cstdio>
#include <fstream>
#include <iostream> 
#include <sstream> 
#include <iomanip>

#include <cctype>
#include <cmath> 
#include <ctime>
#include <cassert>

using namespace std;

#define LL long long
#define PII pair <int, int>
#define VB vector <bool>
#define VI vector <int>
#define VD vector <double>
#define VS vector <string>
#define VPII vector <pair <int, int> >
#define VVI vector < VI >
#define VVB vector < VB >

#define FORN(i, n) for(int i = 0; i < (n); ++i)
#define FOR(i, a, b) for(int i = (a); i <= (b); ++i)
#define FORD(i, a, b) for(int i = (a); i >= (b); --i)
#define FORI(it, X) for(__typeof((X).begin()) it = (X).begin(); it !=(X).end(); ++it) 
#define REPEAT do{ 
#define UNTIL(x) }while(!(x)); 

#define SZ size()
#define BG begin() 
#define EN end() 
#define CL clear()
#define X first
#define Y second
#define RS resize
#define PB push_back
#define MP make_pair
#define ALL(x) x.begin(), x.end()

#define IN_FILE "taxa.in"
#define OUT_FILE "taxa.out"

ifstream fin(IN_FILE);
ofstream fout(OUT_FILE);

int n, m, xs, xf, ys, yf, nrZones, color, color1 = -1, color2 = -1;
VVI a, b;
vector <set <int> > g;

void addEdge(int node1, int node2)
{
	if (node1 == node2) return;
	g[node1].insert(node2);
	g[node2].insert(node1);
}

void fill(int x, int y)
{
	if (x < 1 || x > n || y < 1 || y > m) return;
	if (b[x][y] != 0) 
	{
		addEdge(nrZones, b[x][y]);
		return;
	}
	if (a[x][y] != color) return;
	b[x][y] = nrZones;
	fill(x - 1, y - 1);
	fill(x - 1, y);
	fill(x - 1, y + 1);
	fill(x, y - 1);
	fill(x, y + 1);
	fill(x + 1, y - 1);
	fill(x + 1, y);
	fill(x + 1, y + 1);
}

void getZones()
{
	b.RS(n + 1, VI(m + 1));
	nrZones = 0;
	FOR(i, 1, n)
		FOR(j, 1, m)
			if (b[i][j] == 0) 
			{
				++nrZones;
				g.RS(nrZones + 1);
				color =  a[i][j];
				fill(i, j);
			}
}

int doBF(int startNode, int endNode)
{
	queue <int> fifo;
	VI dist(nrZones + 1, -1);
	dist[startNode] = 0;
	fifo.push(startNode);
	while (!fifo.empty() && dist[endNode] == -1)
	{
		int head = fifo.front();
		for (set<int>::iterator it = g[head].BG; it != g[head].EN; ++it)
		{
			int node = (*it);
			if (dist[node] != -1) continue;
			dist[node] = dist[head] + 1;
			fifo.push(node);
		}
		fifo.pop();
	}
	return dist[endNode];
}

int main()
{
	//Read data
	fin >> n >> m >> xs >> ys >> xf >> yf;
	a.RS(n + 1, VI(m + 1));
	FOR(i, 1, n)
		FOR(j, 1, m) 
		{
			fin >> a[i][j];
			if (color1 == -1) color1 = a[i][j];
			else
				if (color1 != a[i][j]) color2 = a[i][j];
		}
	fin.close();

	//Solve
	getZones();

	//Write data
	fout << doBF(b[xs][ys], b[xf][yf]) * color1 * color2;
	fout.close();

	return 0;
}