//Code by Patcas Csaba

#include <vector>
#include <string> 
#include <set> 
#include <map> 
#include <queue> 
#include <bitset> 
#include <stack>
#include <list>

#include <numeric> 
#include <algorithm> 

#include <cstdio>
#include <fstream>
#include <iostream> 
#include <sstream> 
#include <iomanip>

#include <cctype>
#include <cmath> 
#include <ctime>
#include <cassert>

using namespace std;

#define LL long long
#define PII pair <int, int>
#define VB vector <bool>
#define VI vector <int>
#define VD vector <double>
#define VS vector <string>
#define VPII vector <pair <int, int> >
#define VVI vector < VI >
#define VVB vector < VB >

#define FORN(i, n) for(int i = 0; i < (n); ++i)
#define FOR(i, a, b) for(int i = (a); i <= (b); ++i)
#define FORD(i, a, b) for(int i = (a); i >= (b); --i)
#define FORI(it, X) for(__typeof((X).begin()) it = (X).begin(); it !=(X).end(); ++it) 
#define REPEAT do{ 
#define UNTIL(x) }while(!(x)); 

#define SZ size()
#define BG begin() 
#define EN end() 
#define CL clear()
#define X first
#define Y second
#define RS resize
#define PB push_back
#define MP make_pair
#define ALL(x) x.begin(), x.end()

#define IN_FILE "zone.in"
#define OUT_FILE "zone.out"

ifstream fin(IN_FILE);
ofstream fout(OUT_FILE);

int dx[4] = {-1, 0, 0, 1};
int dy[4] = {0, -1, 1, 0};
int n, m, k, nrZones, nrSuperzones;
VS a;
VVI b;
vector <set <int> > g;
VI area, indSuperzone, areaSuperzone;

void addEdge(int node1, int node2)
{
	g[node1].insert(node2);
	g[node2].insert(node1);
}

void doBF(PII p)
{
	queue <PII> fifo;
	fifo.push(p);
	b[p.X][p.Y] = nrZones;
	area[nrZones] = 0;
	while (!fifo.empty())
	{
		++area[nrZones];
		PII head = fifo.front();
		FORN(i, 4)
		{
			PII newP = MP(head.X + dx[i], head.Y + dy[i]);
			if (newP.X < 0 || newP.X >= n || newP.Y < 0 || newP.Y >= m) continue;
			if (a[newP.X][newP.Y] != a[p.X][p.Y]) 
			{
				if (b[newP.X][newP.Y]) addEdge(nrZones, b[newP.X][newP.Y]);
				continue;
			}
			if (b[newP.X][newP.Y]) continue;
			b[newP.X][newP.Y] = nrZones;
			fifo.push(newP);
		}
		fifo.pop();
	}
}

void findZones()
{
	b.RS(n, VI(m));
	nrZones = 0;
	FORN(i, n)
		FORN(j, m)
			if (!b[i][j]) 
			{
				++nrZones;
				g.RS(nrZones + 1);
				area.RS(nrZones + 1);
				doBF(MP(i, j));
			}
}

void removeZone(int z)
{
	for (set<int>::iterator it = g[z].BG; it != g[z].EN; ++it)
	{
		int aux = (*it);
		g[aux].erase(z);
	}
	g[z].clear();
}

void solve()
{
	bool found;
	do 
	{
		found = false;
		FOR(i, 1, nrZones)
			if (g[i].SZ && g[i].SZ < k)
			{
				found = true;
				removeZone(i);
			}
	}
	while (found);
}

void doBF2(int indZone)
{
	queue <int> fifo;
	fifo.push(indZone);
	indSuperzone[indZone] = nrSuperzones;
	while (!fifo.empty())
	{
		int head = fifo.front();
		areaSuperzone[nrSuperzones] += area[head];
		for (set <int>::iterator it = g[head].BG; it != g[head].EN; ++it)
		{
			int aux = (*it);
			if (indSuperzone[aux] == 0)
			{
				indSuperzone[aux] = nrSuperzones;
				fifo.push(aux);
			}
		}
		fifo.pop();
	}
}

void findSuperzones()
{
	nrSuperzones = 0;
	indSuperzone.RS(nrZones + 1);
	FOR(i, 1, nrZones)
		if (indSuperzone[i] == 0)
		{
			++nrSuperzones;
			areaSuperzone.RS(nrSuperzones + 1);
			doBF2(i);
		}
}

int main()
{
	//Read data
	fin >> n >> m >> k;
	a.RS(n);
	FORN(i, n) fin >> a[i];
	fin.close();

	//Solve
	findZones();
	solve();
	findSuperzones();


	//Write data
	//FORN(i, n)
	//{
	//	FORN(j, m) fout << ((indSuperzone[b[i][j]] == 1) ?  "X" : " ");
	//	fout << endl;
	//}
	fout << *max_element(ALL(areaSuperzone)) << endl;
	
	fout.close();

	return 0;
}